#!/bin/bash

lib_path="./lib"
framework_prefix="ablecloud-framework"

if [ $# -lt 1 ]
then
    echo "Usage: $0 service_name"
    echo "Example: $0 demo-service"
    exit 1
fi
zip_file=$1".zip"


framework=`ls ${lib_path}/${framework_prefix}*.jar`
fw_num=`echo ${framework} | awk -F' ' '{print NF}'`
if [ ${fw_num} -lt 1 ]
then
    echo "could not find cloud service framework jar file"
    exit 2
elif [ ${fw_num} -gt 1 ]
then
    echo "find more than one cloud service framework jar files["${framework}"]"
    exit 2
else
    framework=`echo ${framework} | awk -F' ' '{print $1}'`
fi

zip ${zip_file} -r config/ lib/ start.sh start.cmd
